﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["Data"] == null)
        {
            Session["Data"] = populateGrid();
            this.WebHierarchicalDataGrid1.InitialDataBindDepth = 1;
            this.WebHierarchicalDataGrid1.DataSource = Session["Data"];
            this.WebHierarchicalDataGrid1.DataBind();

            int firstRowIslandsCount = this.WebHierarchicalDataGrid1.GridView.Rows[0].RowIslands.Count;
            int childRowCount = this.WebHierarchicalDataGrid1.GridView.Rows[0].RowIslands[0].Rows.Count;

            resultLbl.Text += firstRowIslandsCount + " and have " + childRowCount + " child rows";
        }
        else
        {
            this.WebHierarchicalDataGrid1.DataSource = (DataSet)Session["Data"];
        }
    }
    public DataSet populateGrid()
    {
        DataSet ds = new DataSet();
        DataTable Parent = new DataTable();
        Parent.TableName = "Parent";
        DataTable Child = new DataTable();
        Child.TableName = "Child";

        Parent.Columns.Add("ID", typeof(System.Int32));
        Parent.Columns.Add("Name");
        Parent.Columns.Add("Test");


        DataColumn[] col = new DataColumn[1];
        col[0] = Parent.Columns["ID"];
        Parent.PrimaryKey = col;

        DataRow row = Parent.NewRow();
        row.SetField<int>("ID", 0);
        row.SetField<string>("Name", "Alice");
        row.SetField<string>("Test", "test1");
        Parent.Rows.Add(row);

        row = Parent.NewRow();
        row.SetField<int>("ID", 1);
        row.SetField<String>("Name", "Bob");
        row.SetField<string>("Test", "test2");
        Parent.Rows.Add(row);


        Child.Columns.Add("ChildID", typeof(System.Int32));
        Child.Columns.Add("ID", typeof(System.Int32));
        Child.Columns.Add("Address");
        Child.Columns.Add("Count", typeof(int));
        Child.Columns.Add("Other");


        DataColumn[] colChild = new DataColumn[1];
        colChild[0] = Child.Columns["ChildID"];
        colChild[0].AutoIncrement = true;
        colChild[0].AutoIncrementSeed = 1;
        colChild[0].DataType = typeof(int);
        Child.PrimaryKey = colChild;

        row = Child.NewRow();
        row.SetField<int>("ChildID", 0);
        row.SetField<int>("ID", 0);
        row.SetField<string>("Address", "Paris");
        row.SetField<string>("Other", "Other");
        row.SetField<int>("Count", 5);
        Child.Rows.Add(row);

        row = Child.NewRow();
        row.SetField<int>("ChildID", 1);
        row.SetField<int>("ID", 1);
        row.SetField<string>("Address", "Rome");
        row.SetField<string>("Other", "Other");
        row.SetField<int>("Count", 9);
        Child.Rows.Add(row);

        row = Child.NewRow();
        row.SetField<int>("ChildID", 2);
        row.SetField<int>("ID", 1);
        row.SetField<string>("Address", "London");
        row.SetField<string>("Other", "Other");
        row.SetField<int>("Count", 2);
        Child.Rows.Add(row);

        row = Child.NewRow();
        row.SetField<int>("ChildID", 3);
        row.SetField<int>("ID", 0);
        row.SetField<string>("Address", "LosAngeles");
        row.SetField<string>("Other", "Other");
        row.SetField<int>("Count", 9);
        Child.Rows.Add(row);

        ds.Tables.Add(Parent);
        ds.Tables.Add(Child);

        DataRelation relation = new DataRelation("IDRelation", Parent.Columns["ID"], Child.Columns["ID"]);
        ds.Relations.Add(relation);

        return ds;
    }
    protected void WebHierarchicalDataGrid1_RowIslandsPopulated(object sender, Infragistics.Web.UI.GridControls.ContainerRowEventArgs e)
    {
        //get the first row items collection
        Session["FirstChildRowItems"] = e.Row.RowIslands[0].Rows[0].Items;
    }
}